import java.lang.reflect.Method;

public class test 
{
	public static void m1 (Object u, Object v, Object w)
	{
		System.out.println ("\tm1 with ref "+(System.identityHashCode (u)==System.identityHashCode (w)?"works":"doesn't work"));
	}

	public static void m1 (Object u, double v, Object w)
	{
		System.out.println ("\tm1 with double "+(System.identityHashCode (u)==System.identityHashCode (w)?"works":"doesn't work"));
	}

	public static void m1 (Object u, float v, Object w)
	{
		System.out.println ("\tm1 with float "+(System.identityHashCode (u)==System.identityHashCode (w)?"works":"doesn't work"));
	}

	public static void m1 (Object u, long v, Object w)
	{
		System.out.println ("\tm1 with long "+(System.identityHashCode (u)==System.identityHashCode (w)?"works":"doesn't work"));
	}

	public static void m1 (Object u, int v, Object w)
	{
		System.out.println ("\tm1 with int "+(System.identityHashCode (u)==System.identityHashCode (w)?"works":"doesn't work"));
	}

	public static void m1 (Object u, short v, Object w)
	{
		System.out.println ("\tm1 with short "+(System.identityHashCode (u)==System.identityHashCode (w)?"works":"doesn't work"));
	}

	public static void m1 (Object u, byte v, Object w)
	{
		System.out.println ("\tm1 with byte "+(System.identityHashCode (u)==System.identityHashCode(w)?"works":"doesn't work"));
	}

	public static void m1 (Object u, char v, Object w)
	{
		System.out.println ("\tm1 with char "+(System.identityHashCode (u)==System.identityHashCode(w)?"works":"doesn't work"));
	}

	public static void m1 (Object u, boolean v, Object w)
	{
		System.out.println ("\tm1 with boolean "+(System.identityHashCode (u)==System.identityHashCode(w)?"works":"doesn't work"));
	}

	public static void invoke (Class[] paramTypes, Object[] paramValues)
	{
		try
		{
			Method m = test.class.getMethod ("m1", paramTypes);

			m.invoke (null, paramValues);
		}
		catch (Exception _)
		{
			_.printStackTrace ();
		}
	}

	public static native void invokeNative (Object o);

	
	public static void main (String[] args)
	{

		Object o = new test ();
		
		System.out.println ("\n\nwith reflection:\n");

		invoke (new Class[]{Object.class, Object.class, Object.class}, new Object[]{o, o, o});

		invoke (new Class[]{Object.class, Double.TYPE, Object.class}, new Object[]{o, new Double(1.0), o});

		invoke (new Class[]{Object.class, Float.TYPE, Object.class}, new Object[]{o, new Float(1.0f), o});

		invoke (new Class[]{Object.class, Long.TYPE, Object.class}, new Object[]{o, new Long(1), o});

		invoke (new Class[]{Object.class, Integer.TYPE, Object.class}, new Object[]{o, new Integer(1), o});

		invoke (new Class[]{Object.class, Short.TYPE, Object.class}, new Object[]{o, new Short((short)1), o});

		invoke (new Class[]{Object.class, Byte.TYPE, Object.class}, new Object[]{o, new Byte((byte)1), o});
		
		invoke (new Class[]{Object.class, Character.TYPE, Object.class}, new Object[]{o, new Character('\001'), o});

		invoke (new Class[]{Object.class, Boolean.TYPE, Object.class}, new Object[]{o, new Boolean (true), o});

		System.out.println ("\n\nwithout reflection:\n");

		m1 (o, o, o);
		
		m1 (o, 1.0, o);

		m1 (o, 1.0f, o);

		m1 (o, (long)1, o);

		m1 (o, (int)1, o);

		m1 (o, (short)1, o);

		m1 (o, (byte)1, o);

		m1 (o, '\1', o);
		
		m1 (o, true, o);

		test.invokeNative (o);
	}
	
	static
	{
		System.loadLibrary("test");
	}
}

	


